Imports VaultClientOperationsLib
Imports System.Xml
Imports System.IO
Imports System.Text

'  Component Information
'
'  Class Name:      VaultLogin.vb
'  Author:          John E. Miller
'  Date:            05/13/2004
'  Description:     This component is part of a custom Vault Search tool built on the 
'                   Vault Client API.  The application simply searches on a specified repository/folder and
'                   returns a text list of all files which match the search terms.
'  Copyright:       2004, John E. Miller/Herbalife International of America, Inc.
'  Disclaimer:      This software/sourcecode is supplied as-is with no warranty, express or implied.
'                   Feel free to modify/redistribute this software/sourcecode at your own peril.  The author and 
'                   Herbalife International of America accept no responsibility for damages (monetary or otherwise) 
'                   incurred as a result of the use of this software.
'  Contact:         johnmi@herbalife.com
'
Public Class VaultLogin

    Inherits System.Windows.Forms.Form

    Private m_Client As ClientInstance

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents lblUserName As System.Windows.Forms.Label
    Friend WithEvents lblPassword As System.Windows.Forms.Label
    Friend WithEvents txtUserName As System.Windows.Forms.TextBox
    Friend WithEvents txtPassword As System.Windows.Forms.TextBox
    Friend WithEvents lblHost As System.Windows.Forms.Label
    Friend WithEvents txtHost As System.Windows.Forms.TextBox
    Friend WithEvents btnCancel As System.Windows.Forms.Button
    Friend WithEvents btnLogin As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(VaultLogin))
        Me.lblUserName = New System.Windows.Forms.Label
        Me.lblPassword = New System.Windows.Forms.Label
        Me.txtUserName = New System.Windows.Forms.TextBox
        Me.txtPassword = New System.Windows.Forms.TextBox
        Me.lblHost = New System.Windows.Forms.Label
        Me.txtHost = New System.Windows.Forms.TextBox
        Me.btnCancel = New System.Windows.Forms.Button
        Me.btnLogin = New System.Windows.Forms.Button
        Me.SuspendLayout()
        '
        'lblUserName
        '
        Me.lblUserName.Location = New System.Drawing.Point(5, 10)
        Me.lblUserName.Name = "lblUserName"
        Me.lblUserName.TabIndex = 0
        Me.lblUserName.Text = "UserName:"
        '
        'lblPassword
        '
        Me.lblPassword.Location = New System.Drawing.Point(5, 35)
        Me.lblPassword.Name = "lblPassword"
        Me.lblPassword.TabIndex = 2
        Me.lblPassword.Text = "Password:"
        '
        'txtUserName
        '
        Me.txtUserName.Location = New System.Drawing.Point(105, 10)
        Me.txtUserName.Name = "txtUserName"
        Me.txtUserName.Size = New System.Drawing.Size(180, 20)
        Me.txtUserName.TabIndex = 1
        Me.txtUserName.Text = "Enter a Username"
        '
        'txtPassword
        '
        Me.txtPassword.ImeMode = System.Windows.Forms.ImeMode.NoControl
        Me.txtPassword.Location = New System.Drawing.Point(105, 35)
        Me.txtPassword.Name = "txtPassword"
        Me.txtPassword.PasswordChar = Microsoft.VisualBasic.ChrW(42)
        Me.txtPassword.Size = New System.Drawing.Size(180, 20)
        Me.txtPassword.TabIndex = 3
        Me.txtPassword.Text = ""
        '
        'lblHost
        '
        Me.lblHost.Location = New System.Drawing.Point(5, 60)
        Me.lblHost.Name = "lblHost"
        Me.lblHost.TabIndex = 4
        Me.lblHost.Text = "Vault Host:"
        '
        'txtHost
        '
        Me.txtHost.Location = New System.Drawing.Point(105, 60)
        Me.txtHost.Name = "txtHost"
        Me.txtHost.Size = New System.Drawing.Size(180, 20)
        Me.txtHost.TabIndex = 5
        Me.txtHost.Text = "http://vault.hrbl.net/VaultService"
        '
        'btnCancel
        '
        Me.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.btnCancel.Location = New System.Drawing.Point(210, 90)
        Me.btnCancel.Name = "btnCancel"
        Me.btnCancel.TabIndex = 7
        Me.btnCancel.Text = "&Cancel"
        '
        'btnLogin
        '
        Me.btnLogin.Location = New System.Drawing.Point(130, 90)
        Me.btnLogin.Name = "btnLogin"
        Me.btnLogin.TabIndex = 6
        Me.btnLogin.Text = "&Login"
        '
        'VaultLogin
        '
        Me.AcceptButton = Me.btnLogin
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.CancelButton = Me.btnCancel
        Me.ClientSize = New System.Drawing.Size(292, 118)
        Me.ControlBox = False
        Me.Controls.Add(Me.btnLogin)
        Me.Controls.Add(Me.btnCancel)
        Me.Controls.Add(Me.txtHost)
        Me.Controls.Add(Me.txtPassword)
        Me.Controls.Add(Me.txtUserName)
        Me.Controls.Add(Me.lblHost)
        Me.Controls.Add(Me.lblPassword)
        Me.Controls.Add(Me.lblUserName)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "VaultLogin"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Login to Vault"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub btnLogin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLogin.Click

        Dim l_Vault As VaultAPI

        If (txtUserName.Text.Equals(String.Empty) Or txtPassword.Text.Equals(String.Empty) Or txtHost.Text.Equals(String.Empty)) Then
            MsgBox("You must enter a valid username, password and host name.", MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "Missing Value")
        Else
            If l_Vault.Authenticate(m_Client, txtUserName.Text, txtPassword.Text, txtHost.Text) Then
                Dim l_frmVaultSearch As New VaultSearch
                l_frmVaultSearch.VaultClient = m_Client
                l_frmVaultSearch.Show()
                Call UpdateConfig()
                Me.Hide()
            Else
                MsgBox("Login Failed.  Ensure Username, Password and Host are valid.", MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "Failed Login")
            End If
        End If

    End Sub

    Private Sub Login_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load

        m_Client = New ClientInstance
        m_Client.Init(VaultClientNetLib.VaultConnection.AccessLevelType.Client)
        Call LoadConfig()

    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        Application.Exit()
    End Sub

    Private Sub LoadConfig()

        Dim l_XMLDoc As XmlDocument
        Dim l_File As File
        Dim l_StreamReader As StreamReader
        Dim l_SBuilder As New StringBuilder

        Try
            If l_File.Exists(String.Concat(AppDomain.CurrentDomain.BaseDirectory.ToString, "SearchConfig.xml")) Then
                l_StreamReader = l_File.OpenText(String.Concat(AppDomain.CurrentDomain.BaseDirectory.ToString, "SearchConfig.xml"))
                l_XMLDoc = New XmlDocument
                l_XMLDoc.LoadXml(l_StreamReader.ReadToEnd)
                l_StreamReader.Close()
                txtUserName.Text = l_XMLDoc.SelectSingleNode("configuration/username").Attributes("value").Value
                txtHost.Text = l_XMLDoc.SelectSingleNode("configuration/hostname").Attributes("value").Value
            Else
                ' create the file
                Call UpdateConfig()
            End If
        Catch ex As System.Exception
            MsgBox(String.Concat("Error:  ", ex.Source, ControlChars.CrLf, ex.Message, ControlChars.CrLf, ex.StackTrace, ControlChars.CrLf), MsgBoxStyle.OKOnly + MsgBoxStyle.Critical, "Error")
        End Try

    End Sub

    Private Sub UpdateConfig()

        Try
            Dim l_XMLTextWriter As New XmlTextWriter(String.Concat(AppDomain.CurrentDomain.BaseDirectory.ToString, "SearchConfig.xml"), Encoding.UTF8)

            With l_XMLTextWriter
                .Formatting = Formatting.Indented
                .WriteStartDocument(True)
                .WriteStartElement("configuration")
                .WriteStartElement("username")
                .WriteAttributeString("value", txtUserName.Text.Trim)
                .WriteFullEndElement()
                .WriteStartElement("hostname")
                .WriteAttributeString("value", txtHost.Text.Trim)
                .WriteFullEndElement()
                .WriteFullEndElement()
                .Flush()
                .Close()
            End With
        Catch ex As System.Exception
            MsgBox(String.Concat("Error:  ", ex.Source, ControlChars.CrLf, ex.Message, ControlChars.CrLf, ex.StackTrace, ControlChars.CrLf), MsgBoxStyle.OKOnly + MsgBoxStyle.Critical, "Error")
        End Try

    End Sub

    Private Sub VaultLogin_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        Application.Exit()
    End Sub

End Class
