Imports VaultClientNetLib.ClientService
Imports VaultClientOperationsLib

'  Component Information
'
'  Class Name:      VaultSearch.vb
'  Author:          John E. Miller
'  Date:            05/13/2004
'  Description:     This component is part of a custom Vault Search tool built on the 
'                   Vault Client API.  The application simply searches on a specified repository/folder and
'                   returns a text list of all files which match the search terms.
'  Copyright:       2004, John E. Miller/Herbalife International of America, Inc.
'  Disclaimer:      This software/sourcecode is supplied as-is with no warranty, express or implied.
'                   Feel free to modify/redistribute this software/sourcecode at your own peril.  The author and 
'                   Herbalife International of America accept no responsibility for damages (monetary or otherwise) 
'                   incurred as a result of the use of this software.
'  Contact:         johnmi@herbalife.com

Public Class VaultSearch

    Inherits System.Windows.Forms.Form

    Private m_Client As ClientInstance
    Dim m_VaultAPI As VaultAPI

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents lblReps As System.Windows.Forms.Label
    Friend WithEvents cmbReps As System.Windows.Forms.ComboBox
    Friend WithEvents tvFolders As System.Windows.Forms.TreeView
    Friend WithEvents imgList As System.Windows.Forms.ImageList
    Friend WithEvents lblRepFolders As System.Windows.Forms.Label
    Friend WithEvents lblSearchTerm As System.Windows.Forms.Label
    Friend WithEvents txtSearchTerm As System.Windows.Forms.TextBox
    Friend WithEvents btnSearch As System.Windows.Forms.Button
    Friend WithEvents chkCase As System.Windows.Forms.CheckBox
    Friend WithEvents chkWildcard As System.Windows.Forms.CheckBox
    Friend WithEvents btnClose As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(VaultSearch))
        Me.lblReps = New System.Windows.Forms.Label
        Me.cmbReps = New System.Windows.Forms.ComboBox
        Me.tvFolders = New System.Windows.Forms.TreeView
        Me.imgList = New System.Windows.Forms.ImageList(Me.components)
        Me.lblRepFolders = New System.Windows.Forms.Label
        Me.lblSearchTerm = New System.Windows.Forms.Label
        Me.txtSearchTerm = New System.Windows.Forms.TextBox
        Me.btnSearch = New System.Windows.Forms.Button
        Me.chkCase = New System.Windows.Forms.CheckBox
        Me.chkWildcard = New System.Windows.Forms.CheckBox
        Me.btnClose = New System.Windows.Forms.Button
        Me.SuspendLayout()
        '
        'lblReps
        '
        Me.lblReps.Location = New System.Drawing.Point(10, 10)
        Me.lblReps.Name = "lblReps"
        Me.lblReps.TabIndex = 1
        Me.lblReps.Text = "Vault Repository:"
        '
        'cmbReps
        '
        Me.cmbReps.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cmbReps.Location = New System.Drawing.Point(10, 30)
        Me.cmbReps.MaxDropDownItems = 25
        Me.cmbReps.Name = "cmbReps"
        Me.cmbReps.Size = New System.Drawing.Size(150, 21)
        Me.cmbReps.TabIndex = 0
        '
        'tvFolders
        '
        Me.tvFolders.ImageList = Me.imgList
        Me.tvFolders.Indent = 20
        Me.tvFolders.Location = New System.Drawing.Point(10, 80)
        Me.tvFolders.Name = "tvFolders"
        Me.tvFolders.Size = New System.Drawing.Size(390, 220)
        Me.tvFolders.TabIndex = 2
        '
        'imgList
        '
        Me.imgList.ImageSize = New System.Drawing.Size(16, 16)
        Me.imgList.ImageStream = CType(resources.GetObject("imgList.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.imgList.TransparentColor = System.Drawing.Color.Transparent
        '
        'lblRepFolders
        '
        Me.lblRepFolders.Location = New System.Drawing.Point(10, 60)
        Me.lblRepFolders.Name = "lblRepFolders"
        Me.lblRepFolders.Size = New System.Drawing.Size(100, 15)
        Me.lblRepFolders.TabIndex = 4
        Me.lblRepFolders.Text = "Folders:"
        '
        'lblSearchTerm
        '
        Me.lblSearchTerm.Location = New System.Drawing.Point(10, 310)
        Me.lblSearchTerm.Name = "lblSearchTerm"
        Me.lblSearchTerm.Size = New System.Drawing.Size(115, 23)
        Me.lblSearchTerm.TabIndex = 5
        Me.lblSearchTerm.Text = "Search Filenames for:"
        '
        'txtSearchTerm
        '
        Me.txtSearchTerm.Location = New System.Drawing.Point(10, 330)
        Me.txtSearchTerm.Name = "txtSearchTerm"
        Me.txtSearchTerm.Size = New System.Drawing.Size(140, 20)
        Me.txtSearchTerm.TabIndex = 4
        Me.txtSearchTerm.Text = ""
        '
        'btnSearch
        '
        Me.btnSearch.Location = New System.Drawing.Point(325, 360)
        Me.btnSearch.Name = "btnSearch"
        Me.btnSearch.TabIndex = 7
        Me.btnSearch.Text = "&Search"
        '
        'chkCase
        '
        Me.chkCase.Location = New System.Drawing.Point(160, 330)
        Me.chkCase.Name = "chkCase"
        Me.chkCase.Size = New System.Drawing.Size(120, 24)
        Me.chkCase.TabIndex = 5
        Me.chkCase.Text = "Case Sensitive?"
        '
        'chkWildcard
        '
        Me.chkWildcard.Location = New System.Drawing.Point(280, 330)
        Me.chkWildcard.Name = "chkWildcard"
        Me.chkWildcard.Size = New System.Drawing.Size(120, 24)
        Me.chkWildcard.TabIndex = 6
        Me.chkWildcard.Text = "Exact Match?"
        '
        'btnClose
        '
        Me.btnClose.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.btnClose.Location = New System.Drawing.Point(325, 385)
        Me.btnClose.Name = "btnClose"
        Me.btnClose.TabIndex = 8
        Me.btnClose.Text = "&Close"
        '
        'VaultSearch
        '
        Me.AcceptButton = Me.btnSearch
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.CancelButton = Me.btnClose
        Me.ClientSize = New System.Drawing.Size(407, 415)
        Me.Controls.Add(Me.btnClose)
        Me.Controls.Add(Me.chkWildcard)
        Me.Controls.Add(Me.chkCase)
        Me.Controls.Add(Me.btnSearch)
        Me.Controls.Add(Me.txtSearchTerm)
        Me.Controls.Add(Me.lblSearchTerm)
        Me.Controls.Add(Me.lblRepFolders)
        Me.Controls.Add(Me.tvFolders)
        Me.Controls.Add(Me.cmbReps)
        Me.Controls.Add(Me.lblReps)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.MaximizeBox = False
        Me.Name = "VaultSearch"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Vault Search UI"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub VaultSearch_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim l_arrRepInfo As New ArrayList

        Try
            ' load the repository drop-down list....
            l_arrRepInfo.Add(New VaultRepInfo("Choose a Repository", "NULL", "NULL"))
            For Each l_RepInfo As VaultRepositoryInfo In m_VaultAPI.ListRepositories(m_Client)
                l_arrRepInfo.Add(New VaultRepInfo(l_RepInfo.RepName.ToString, l_RepInfo.UniqueRepID.ToString, l_RepInfo.RepID))
            Next
            cmbReps.DataSource = l_arrRepInfo
            cmbReps.DisplayMember = "RepName"
            cmbReps.ValueMember = "UniqueID"
            cmbReps.SelectedIndex = 0
        Catch ex As System.Exception
            MsgBox(String.Concat("Error:  ", ex.Source, ControlChars.CrLf, ex.Message, ControlChars.CrLf, ex.StackTrace, ControlChars.CrLf), MsgBoxStyle.OKOnly + MsgBoxStyle.Critical, "Error")
        End Try

    End Sub

    Public WriteOnly Property VaultClient() As ClientInstance
        '  Must set this property before anything can be done....
        Set(ByVal Value As ClientInstance)
            m_Client = Value
        End Set
    End Property

    Public Class VaultRepInfo

        Private strRepName As String
        Private strRepUniqueId As String
        Private strRepID

        Public Sub New(ByVal RepName As String, ByVal UniqueId As String, ByVal RepId As String)
            MyBase.New()
            Me.strRepName = RepName
            Me.strRepUniqueId = UniqueId
            Me.strRepID = RepId
        End Sub

        Public ReadOnly Property RepName() As String
            Get
                Return strRepName
            End Get
        End Property

        Public ReadOnly Property UniqueID() As String
            Get
                Return strRepUniqueId
            End Get
        End Property

        Public ReadOnly Property RepID() As String
            Get
                Return strRepID
            End Get
        End Property

        Public Overrides Function ToString() As String
            Return Me.strRepName
        End Function

    End Class

    Private Sub cmbReps_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmbReps.SelectedIndexChanged

        Try
            tvFolders.Nodes.Clear()
            If Not cmbReps.SelectedIndex = 0 Then
                Dim l_VaultRepInfo As VaultRepInfo = cmbReps.SelectedItem
                m_VaultAPI.SetActiveRepository(m_Client, l_VaultRepInfo.RepID, l_VaultRepInfo.UniqueID)
                'Call m_VaultAPI.ListFolders(m_Client)
                Dim l_FolderColl As VaultClientFolderColl = m_Client.Repository.Root.Folders
                For Each l_Folder As VaultClientFolder In l_FolderColl
                    Dim l_TreeNode As New TreeNode(l_Folder.Name.ToString)
                    l_TreeNode.ImageIndex = 0
                    l_TreeNode.SelectedImageIndex = 1
                    l_TreeNode.Tag = l_Folder
                    AddTreeNodes(l_Folder, l_TreeNode)
                    tvFolders.Nodes.Add(l_TreeNode)
                Next
                tvFolders.SelectedNode = tvFolders.Nodes(0)
            End If
        Catch ex As System.Exception
            MsgBox(String.Concat("Error:  ", ex.Source, ControlChars.CrLf, ex.Message, ControlChars.CrLf, ex.StackTrace, ControlChars.CrLf), MsgBoxStyle.OKOnly + MsgBoxStyle.Critical, "Error")
        End Try

    End Sub

    Private Sub AddTreeNodes(ByVal vaultFolder As VaultClientFolder, ByRef treeNode As TreeNode)

        Dim l_FolderColl As VaultClientFolderColl = vaultFolder.Folders

        Try
            For Each l_Folder As VaultClientFolder In l_FolderColl
                Dim l_TreeNode As New TreeNode(l_Folder.Name.ToString)
                l_TreeNode.ImageIndex = 0
                l_TreeNode.SelectedImageIndex = 1
                l_TreeNode.Tag = l_Folder
                treeNode.Nodes.Add(l_TreeNode)
                '  call recursively ....
                AddTreeNodes(l_Folder, l_TreeNode)
            Next
        Catch ex As System.Exception
            MsgBox(String.Concat("Error:  ", ex.Source, ControlChars.CrLf, ex.Message, ControlChars.CrLf, ex.StackTrace, ControlChars.CrLf), MsgBoxStyle.OKOnly + MsgBoxStyle.Critical, "Error")
        End Try

    End Sub

    Private Sub btnSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearch.Click

        Dim l_SearchReturn As New ArrayList

        Try
            If txtSearchTerm.Text.Trim.Length > 0 Then
                If Not tvFolders.SelectedNode Is Nothing Then
                    Dim l_ClientFolder As VaultClientFolder = tvFolders.SelectedNode.Tag
                    m_VaultAPI.SearchForFileName(l_ClientFolder, txtSearchTerm.Text, l_SearchReturn, chkWildcard.Checked, chkCase.Checked)
                    If l_SearchReturn.Count > 0 Then
                        Dim l_SearchResults As New VaultResults
                        l_SearchResults.SearchFragment = txtSearchTerm.Text
                        l_SearchResults.SearchResults = l_SearchReturn
                        l_SearchResults.ShowDialog()
                    Else
                        MsgBox("The search did not return any files.", MsgBoxStyle.OKOnly + MsgBoxStyle.Information, "No Files Found")
                    End If
                Else
                    MsgBox("You must select a node in the repository to Search.", MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "No Node Selected")
                    cmbReps.Focus()
                End If
            Else
                MsgBox("You must enter a filename to search for.", MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "No Search Term(s)")
                txtSearchTerm.Focus()
            End If
        Catch ex As System.Exception
            MsgBox(String.Concat("Error:  ", ex.Source, ControlChars.CrLf, ex.Message, ControlChars.CrLf, ex.StackTrace, ControlChars.CrLf), MsgBoxStyle.OKOnly + MsgBoxStyle.Critical, "Error")
        End Try

    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Application.Exit()
    End Sub

    Private Sub VaultSearch_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        Application.Exit()
    End Sub

End Class
